//+------------------------------------------------------------------+
//|      . :  |
//| --   -;                                     |
//| --   "";                               |
//| --       ;     |
//| --      .               |
//| Copyright  2010, Son_Of_Earth                                   |
//+------------------------------------------------------------------+
#property copyright "Son_Of_Earth"
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Aqua  
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Coral
#property indicator_color5 Coral
#property indicator_color6 YellowGreen
#property indicator_color7 MediumTurquoise
#property indicator_color8 MediumTurquoise
#property indicator_width1 2
//  .   BID  ASK,      #I
extern string    Symbol1.Name="FDAXZ0#I"; //  1.   ,     .
extern string    Symbol2.Name="FESXZ0#I"; //  2.
extern string    Symbol3.Name="FCEZ0#I";  //  3.
//  Symbol.Vol         EquityScale:
// --  EquityScale=true, Symbol.Vol -     - ;
// --  EquityScale=false, Symbol.Vol -    - ,
//                Lots*TickValue/TickSize;
//     ( + Buy, - Sell)
extern double    Symbol1.Vol=2;          //      1- . 
extern double    Symbol2.Vol=-5.5;           //      2- .
extern double    Symbol3.Vol=-4.2;           //      3- . 
extern bool      EquityScale = true;      //   .
extern bool      BidAsk.Show = true;      //   -
extern int       Channel.Mode = 1;        //   
                                          // -- 0 -  
                                          // -- 1 -  ,   Channel.Period
                                          // -- 2 - ,  Channel.Period & Channel.Dev
extern int       Channel.Period = 100;    //   
extern double    Channel.Dev = 1.0;       //    
extern double Alert.BidMore = EMPTY;      //  ,    
extern double Alert.AskLess = EMPTY;      //  ,    

double last[];
double bid[];
double ask[];
double EnvUp2[], EnvUp1[], MA[], EnvDn1[], EnvDn2[];

int wndNum;                                //   
string wndName;                            //  
int soundCount; 
double Symbol1.K, Symbol2.K, Symbol3.K;    //  
string sname;
bool isFirst;

string oComment="spreadParam";             //   

//===============================================================

int init(){
  isFirst=true;
  //    -
  if(Symbol1.Name=="") Symbol1.Name=Symbol();
  Symbol1.Name=StringUpper(Symbol1.Name);
  Symbol2.Name=StringUpper(Symbol2.Name);
  Symbol3.Name=StringUpper(Symbol3.Name);
  
  //         ,
  //        ,   
  if(EquityScale) {
    Symbol1.K = MarketInfo(Symbol1.Name, MODE_TICKVALUE)/MarketInfo(Symbol1.Name, MODE_TICKSIZE);
    Symbol2.K = MarketInfo(Symbol2.Name, MODE_TICKVALUE)/MarketInfo(Symbol2.Name, MODE_TICKSIZE);
    Symbol3.K = MarketInfo(Symbol3.Name, MODE_TICKVALUE)/MarketInfo(Symbol3.Name, MODE_TICKSIZE);
  }
  else { //         Symbol.Vol
    Symbol1.K = 1;
    Symbol2.K = 1;
    Symbol3.K = 1;
  }
  
  //  ,     
  datetime d1,d2,d3;
  d1=iTime(Symbol1.Name,0,iBars(Symbol1.Name,0)-1);
  d2=iTime(Symbol2.Name,0,iBars(Symbol2.Name,0)-1);
  d3=iTime(Symbol3.Name,0,iBars(Symbol3.Name,0)-1);
  int StartBar = Bars - MathMax(iBarShift(NULL,0,MathMax(MathMax(d1,d2),d3)),0);

  //   
  string s="";
  if(Channel.Mode==1)
    sname=sname+"("+Channel.Period+")";
  else if(Channel.Mode==2)
    sname=sname+"("+Channel.Period+","+DoubleToStr(Channel.Dev,2)+")";

  sname = DoubleToStr(Symbol1.Vol,2)+"*"+DoubleToStr(Symbol1.K,0)+"*"+Symbol1.Name;
  if(Symbol2.Vol>0)
    sname=sname+"+";
  else
    sname=sname+"-";
  sname=sname+DoubleToStr(MathAbs(Symbol2.Vol),2)+"*"+DoubleToStr(Symbol2.K,0)+"*"+Symbol2.Name;
  if(Symbol3.Vol>0)
    sname=sname+"+";
  else
    sname=sname+"-";
  sname=sname+DoubleToStr(MathAbs(Symbol3.Vol),2)+"*"+DoubleToStr(Symbol3.K,0)+"*"+Symbol3.Name+s;
    
  //    
  SetIndexShift(0,0);
  SetIndexBuffer(0,last);
  SetIndexStyle(0,DRAW_LINE);
  SetIndexLabel(0,"Last");
  SetIndexDrawBegin(1,StartBar);

  if(BidAsk.Show) {
    SetIndexShift(1,0);
    SetIndexBuffer(1,ask);
    SetIndexStyle(1,DRAW_LINE);
    SetIndexLabel(1,"Ask");
    SetIndexDrawBegin(1,StartBar);

    SetIndexShift(2,0);
    SetIndexBuffer(2,bid);
    SetIndexStyle(2,DRAW_LINE);
    SetIndexLabel(2,"Bid");
    SetIndexDrawBegin(2,StartBar);
  }

  if(Channel.Mode>0) {
    SetIndexShift(3,0);
    SetIndexBuffer(3,EnvUp2);
    SetIndexStyle(3,DRAW_LINE);
    SetIndexLabel(3,"Up2");
    SetIndexDrawBegin(3,StartBar+Channel.Period);

    SetIndexShift(4,0);
    SetIndexBuffer(4,EnvUp1);
    SetIndexStyle(4,DRAW_LINE);
    SetIndexLabel(4,"Up1");
    SetIndexDrawBegin(4,StartBar+Channel.Period);

    SetIndexShift(5,0);
    SetIndexBuffer(5,MA);
    SetIndexStyle(5,DRAW_LINE);
    SetIndexLabel(5,"MA");
    SetIndexDrawBegin(5,StartBar+Channel.Period);

    SetIndexShift(6,0);
    SetIndexBuffer(6,EnvDn1);
    SetIndexStyle(6,DRAW_LINE);
    SetIndexLabel(6,"Dn1");
    SetIndexDrawBegin(6,StartBar+Channel.Period);

    SetIndexShift(7,0);
    SetIndexBuffer(7,EnvDn2);
    SetIndexStyle(7,DRAW_LINE);
    SetIndexLabel(7,"Dn2");
    SetIndexDrawBegin(7,StartBar+Channel.Period);
  }

  soundCount=10;

  return(0);
}

//===============================================================

int deinit()  {
  //    
  DeleteObject(oComment);
  return(0);  
}

//===============================================================

int start()
{
  //     1   
  if(isFirst) {
    //        
    wndNum=WindowFind(WindowExpertName());
    wndName=WindowExpertName()+wndNum; 
    DrawLabel(oComment, sname, 8, DarkGray, 16);
    isFirst=false;
  }

  int    counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(counted_bars>0) counted_bars--; 
  int limit=Bars-counted_bars;

  int i;
  datetime t;

  //  -
  if(BidAsk.Show) {
    double _ask;
    double _bid;
  
    if(Symbol1.Vol>0) {
      _ask = Symbol1.Vol*Symbol1.K*MarketInfo(Symbol1.Name,MODE_ASK);
      _bid = Symbol1.Vol*Symbol1.K*MarketInfo(Symbol1.Name,MODE_BID);
    } else {
      _ask = Symbol1.Vol*Symbol1.K*MarketInfo(Symbol1.Name,MODE_BID);
      _bid = Symbol1.Vol*Symbol1.K*MarketInfo(Symbol1.Name,MODE_ASK);
    }
    if(Symbol2.Vol>0) {
      _ask += Symbol2.Vol*Symbol2.K*MarketInfo(Symbol2.Name,MODE_ASK);
      _bid += Symbol2.Vol*Symbol2.K*MarketInfo(Symbol2.Name,MODE_BID);
    } else {
      _ask += Symbol2.Vol*Symbol2.K*MarketInfo(Symbol2.Name,MODE_BID);
      _bid += Symbol2.Vol*Symbol2.K*MarketInfo(Symbol2.Name,MODE_ASK);
    }
    if(Symbol3.Vol>0) {
      _ask += Symbol3.Vol*Symbol3.K*MarketInfo(Symbol3.Name,MODE_ASK);
      _bid += Symbol3.Vol*Symbol3.K*MarketInfo(Symbol3.Name,MODE_BID);
    } else {
      _ask += Symbol3.Vol*Symbol3.K*MarketInfo(Symbol3.Name,MODE_BID);
      _bid += Symbol3.Vol*Symbol3.K*MarketInfo(Symbol3.Name,MODE_ASK);
    }
  }
 
  //   
  for (i=0;i<limit;i++) 
  {
    t=Time[i];
    last[i] = Symbol1.Vol*Symbol1.K*iClose(Symbol1.Name,0,iBarShift(Symbol1.Name,0,t)) 
            + Symbol2.Vol*Symbol2.K*iClose(Symbol2.Name,0,iBarShift(Symbol2.Name,0,t))
            + Symbol3.Vol*Symbol3.K*iClose(Symbol3.Name,0,iBarShift(Symbol3.Name,0,t));
    if(BidAsk.Show) {
      ask[i]=_ask;
      bid[i]=_bid;
    }
  }

  //         
  if(Channel.Mode>0) {
    double StdDev;
    for(i=0;i<limit;i++) {
      MA[i]=iMAOnArray(last,0,Channel.Period,0,MODE_SMA,i);
      //    
      if(Channel.Mode==1) {
        StdDev=iStdDevOnArray(last,0,Channel.Period,0,MODE_SMA,i);
        EnvUp2[i]=MA[i]+2*StdDev;
        EnvUp1[i]=MA[i]+StdDev;
        EnvDn1[i]=MA[i]-StdDev;
        EnvDn2[i]=MA[i]-2*StdDev;
      }
      //  
      else {      
        EnvUp2[i]=iEnvelopesOnArray(last,0,Channel.Period,MODE_SMA,0,Channel.Dev,MODE_UPPER,i);
        EnvUp1[i]=iEnvelopesOnArray(last,0,Channel.Period,MODE_SMA,0,Channel.Dev/2,MODE_UPPER,i);
        EnvDn1[i]=iEnvelopesOnArray(last,0,Channel.Period,MODE_SMA,0,Channel.Dev/2,MODE_LOWER,i);
        EnvDn2[i]=iEnvelopesOnArray(last,0,Channel.Period,MODE_SMA,0,Channel.Dev,MODE_LOWER,i);
      }
    }
  }
  
  //        
  //        
  if (soundCount>0 && 
      ((Alert.BidMore!=EMPTY &&  bid[0]>Alert.BidMore) || (Alert.AskLess!=EMPTY && ask[0]<Alert.AskLess))) {
    PlaySound("alert2.wav");
    Print(Symbol1.Name+"-"+Symbol2.Name+"-"+Symbol3.Name+": channel width condition is achived"); 
    soundCount--;
  }
}


//-----------------------------------------

//  
void DrawLabel(string aName, string aText, int aFontSize, color aColor, int aValue) {
  string objName=aName+wndName;
  ObjectCreate(objName, OBJ_LABEL, wndNum, 0, 0);
  ObjectSetText(objName, aText, aFontSize, "Verdana", aColor);
  ObjectSet(objName, OBJPROP_CORNER, 0);
  ObjectSet(objName, OBJPROP_XDISTANCE, 4);
  ObjectSet(objName, OBJPROP_YDISTANCE, aValue); 
}

//   
void DeleteObject(string name) {
  ObjectDelete(name+wndName);
}

string StringUpper(string s) {
  int c, i, k=StringLen(s), n;
  for (i=0; i<k; i++) {
    n=0;
    c=StringGetChar(s, i);
    if (c>96 && c<123) n=c-32;    // a-z -> A-Z
    if (c>223 && c<256) n=c-32;   // - -> -
    if (c==184) n=168;            //    ->  
    if (n>0) s=StringSetChar(s, i, n);
  }
  return(s);
}

